"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const fiber_1 = require("@react-three/fiber");
const drei_1 = require("@react-three/drei");
const wouter_1 = require("wouter");
const uuid_by_string_1 = __importDefault(require("uuid-by-string"));
const THREE = __importStar(require("three"));
const three_1 = require("three");
const GOLDENRATIO = 1.61803398875;
// eslint-disable-next-line react/prop-types
const ThreeCover = ({ images }) => {
    return (react_1.default.createElement(fiber_1.Canvas, { gl: { alpha: false }, dpr: [1, 1.5], camera: { fov: 70, position: [0, 2, 15] } },
        react_1.default.createElement("color", { attach: "background", args: ['#191920'] }),
        react_1.default.createElement("fog", { attach: "fog", args: ['#191920', 0, 15] }),
        react_1.default.createElement(drei_1.Environment, { preset: "city" }),
        react_1.default.createElement("group", { position: [0, -0.5, 0] },
            react_1.default.createElement(Frames, { images: images }),
            react_1.default.createElement("mesh", { rotation: [-Math.PI / 2, 0, 0], position: [0, 0, 0] },
                react_1.default.createElement("planeGeometry", { args: [50, 50] }),
                // @ts-ignore
                react_1.default.createElement(drei_1.MeshReflectorMaterial, { blur: [300, 100], resolution: 2048, mixBlur: 1, mixStrength: 40, roughness: 1, depthScale: 1.2, minDepthThreshold: 0.4, maxDepthThreshold: 1.4, color: "#050505", metalness: 0.5 })))));
};
// eslint-disable-next-line react/prop-types
const Frames = ({ images, q = new three_1.Quaternion(), p = new three_1.Vector3() }) => {
    const ref = (0, react_1.useRef)();
    const clicked = (0, react_1.useRef)();
    const [, params] = (0, wouter_1.useRoute)('/item/:id');
    const [, setLocation] = (0, wouter_1.useLocation)();
    (0, react_1.useEffect)(() => {
        // @ts-ignore
        clicked.current = ref.current.getObjectByName(params?.id);
        if (clicked.current) {
            // @ts-ignore
            clicked.current.parent.updateWorldMatrix(true, true);
            // @ts-ignore
            clicked.current.parent.localToWorld(p.set(0, GOLDENRATIO / 2, 1.25));
            // @ts-ignore
            clicked.current.parent.getWorldQuaternion(q);
        }
        else {
            p.set(0, 0, 5.5);
            q.identity();
        }
    });
    (0, fiber_1.useFrame)((state) => {
        state.camera.position.lerp(p, 0.025);
        state.camera.quaternion.slerp(q, 0.025);
    });
    return (react_1.default.createElement("group", { ref: ref, onClick: (e) => (e.stopPropagation(),
            setLocation(clicked.current === e.object ? '/' : '/item/' + e.object.name)), onPointerMissed: () => setLocation('/') }, images.map((props) => (
    // eslint-disable-next-line react/prop-types
    react_1.default.createElement(Frame, { key: props.url, ...props })))));
};
// eslint-disable-next-line react/prop-types
const Frame = ({ url, c = new three_1.Color(), ...props }) => {
    const [hovered, hover] = (0, react_1.useState)(false);
    const [rnd] = (0, react_1.useState)(() => Math.random());
    const image = (0, react_1.useRef)();
    const frame = (0, react_1.useRef)();
    const name = (0, uuid_by_string_1.default)(url);
    (0, drei_1.useCursor)(hovered);
    (0, fiber_1.useFrame)((state) => {
        // @ts-ignore
        image.current.material.zoom = 2 + Math.sin(rnd * 10000 + state.clock.elapsedTime / 3) / 2;
        // @ts-ignore
        image.current.scale.x = THREE.MathUtils.lerp(
        // @ts-ignore
        image.current.scale.x, 0.85 * (hovered ? 0.85 : 1), 0.1);
        // @ts-ignore
        image.current.scale.y = THREE.MathUtils.lerp(
        // @ts-ignore
        image.current.scale.y, 0.9 * (hovered ? 0.905 : 1), 0.1);
        // @ts-ignore
        frame.current.material.color.lerp(c.set(hovered ? 'orange' : 'white'), 0.1);
    });
    return (react_1.default.createElement("group", { ...props },
        react_1.default.createElement("mesh", { name: name, onPointerOver: (e) => (e.stopPropagation(), hover(true)), onPointerOut: () => hover(false), scale: [1, GOLDENRATIO, 0.05], position: [0, GOLDENRATIO / 2, 0] },
            react_1.default.createElement("boxGeometry", null),
            react_1.default.createElement("meshStandardMaterial", { color: "#151515", metalness: 0.5, roughness: 0.5, envMapIntensity: 2 }),
            react_1.default.createElement("mesh", { ref: frame, raycast: () => null, scale: [0.9, 0.93, 0.9], position: [0, 0, 0.2] },
                react_1.default.createElement("boxGeometry", null),
                react_1.default.createElement("meshBasicMaterial", { toneMapped: false, fog: false })),
            // @ts-ignore
            react_1.default.createElement(drei_1.Image, { raycast: () => null, ref: image, position: [0, 0, 0.7], url: url }))));
};
exports.default = ThreeCover;
